/*  Copyright (C) 2006,2007  Joris Mooij  [joris at jorismooij dot nl]
    Radboud University Nijmegen, The Netherlands
    
    This file is part of libDAI.

    libDAI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    libDAI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with libDAI; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


#include "factorgraph.h"
#include <iostream>
#include <stdlib.h>


using namespace std;
using namespace libDAI;


int main( int argc, char *argv[] ) {
    if( argc != 4 ) {
        cout << "Usage: " << argv[0] << " <beta> <in.fg> <out.fg>" << endl << endl;
        cout << "Exponentiates all factors in <in.fg> with <beta> and writes" << endl;
        cout << "result to <out.fg>." << endl;
        return 1;
    } else {
        double beta = atof(argv[1]);

        // Read factorgraph
        FactorGraph fg;
        char *infile = argv[2];
        fg.ReadFromFile( infile );

        for( size_t I = 0; I < fg.nrFactors(); I++ )
            fg.setFactor(I, fg.factor(I) ^ beta);
        fg.WriteToFile( argv[3] );
        return 0;
    }
}
