/*  Copyright (C) 2006,2007  Joris Mooij  [joris at jorismooij dot nl]
    Radboud University Nijmegen, The Netherlands
    
    This file is part of libDAI.

    libDAI is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    libDAI is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with libDAI; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


#include <iostream>
#include <iterator>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <algorithm>
#include <functional>
#include "factorgraph.h"
#include "exceptions.h"


using namespace std;
using namespace libDAI;


/*std::ostream& operator << (std::ostream& os, const FactorGraph& fg) {
    os << fg.nrFactors() << endl;

    for( size_t I = 0; I < fg.nrFactors(); I++ ) {
        os << endl;
        os << fg.factor(I).vars().size() << endl;
        for( VarSet::const_iterator i = fg.factor(I).vars().begin(); i != fg.factor(I).vars().end(); i++ )
            os << i->label() << " ";
        os << endl;
        for( VarSet::const_iterator i = fg.factor(I).vars().begin(); i != fg.factor(I).vars().end(); i++ )
            os << i->states() << " ";
        os << endl;
        size_t nr_nonzeros = 0;
        for( size_t k = 0; k < fg.factor(I).stateSpace(); k++ )
            if( fg.factor(I)[k] != 0.0 )
                nr_nonzeros++;
        os << nr_nonzeros << endl;
        for( size_t k = 0; k < fg.factor(I).stateSpace(); k++ )
            if( fg.factor(I)[k] != 0.0 ) {
                char buf[20];
                sprintf(buf,"%18.14g", fg.factor(I)[k]);
                os << k << " " << buf << endl;
            }
    }

    return(os);
}*/


/*
std::istream& operator >> (std::istream& is, FactorGraph& fg) {
    long verbose = 0;

    try {
        vector<Factor> factors;
        size_t nr_f;
        string line;
        
        while( (is.peek()) == '#' )
            getline(is,line);
        is >> nr_f;
        if( is.fail() )
            DAI_THROW(INVALID_FACTORGRAPH_FILE);
        if( verbose >= 2 )
            cout << "Reading " << nr_f << " factors..." << endl;

        getline (is,line);
        if( is.fail() )
            DAI_THROW(INVALID_FACTORGRAPH_FILE);

        for( size_t I = 0; I < nr_f; I++ ) {
            if( verbose >= 3 )
                cout << "Reading factor " << I << "..." << endl;
            size_t nr_members;
            while( (is.peek()) == '#' )
                getline(is,line);
            is >> nr_members;
            if( verbose >= 3 )
                cout << "  nr_members: " << nr_members << endl;

            vector<long> labels;
            for( size_t mi = 0; mi < nr_members; mi++ ) {
                long mi_label;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> mi_label;
                labels.push_back(mi_label);
            }
            if( verbose >= 3 ) {
                cout << "  labels: ";
                copy (labels.begin(), labels.end(), ostream_iterator<int>(cout, " "));
                cout << endl;
            }

            vector<size_t> dims;
            for( size_t mi = 0; mi < nr_members; mi++ ) {
                size_t mi_dim;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> mi_dim;
                dims.push_back(mi_dim);
            }
            if( verbose >= 3 ) {
                cout << "  dimensions: ";
                copy (dims.begin(), dims.end(), ostream_iterator<int>(cout, " "));
                cout << endl;
            }

            // add the Factor
            VarSet I_vars;
            for( size_t mi = 0; mi < nr_members; mi++ )
                I_vars.insert( Var(labels[mi], dims[mi]) );
            factors.push_back(Factor(I_vars,0.0));
            
            // calculate permutation sigma (internally, members are sorted)
            vector<long> sigma(nr_members,0);
            VarSet::iterator j = I_vars.begin();
            for( size_t mi = 0; mi < nr_members; mi++,j++ ) {
                long search_for = j->label();
                vector<long>::iterator j_loc = find(labels.begin(),labels.end(),search_for);
                sigma[mi] = j_loc - labels.begin();
            }
            if( verbose >= 3 ) {
                cout << "  sigma: ";
                copy( sigma.begin(), sigma.end(), ostream_iterator<int>(cout," "));
                cout << endl;
            }

            // calculate multindices
            vector<size_t> sdims(nr_members,0);
            for( size_t k = 0; k < nr_members; k++ ) {
                sdims[k] = dims[sigma[k]];
            }
            multind mi(dims);
            multind smi(sdims);
            if( verbose >= 3 ) {
                cout << "  mi.max(): " << mi.max() << endl;
                cout << "       ";
                for( size_t k=0; k < nr_members; k++ ) 
                    cout << labels[k] << " ";
                cout << "   ";
                for( size_t k=0; k < nr_members; k++ ) 
                    cout << labels[sigma[k]] << " ";
                cout << endl;
            }
            
            // read values
            size_t nr_nonzeros;
            while( (is.peek()) == '#' )
                getline(is,line);
            is >> nr_nonzeros;
            if( verbose >= 3 ) 
                cout << "  nonzeroes: " << nr_nonzeros << endl;
            for( size_t k = 0; k < nr_nonzeros; k++ ) {
                size_t li;
                double val;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> li;
                while( (is.peek()) == '#' )
                    getline(is,line);
                is >> val;

                vector<size_t> vi = mi.vi(li);
                vector<size_t> svi(vi.size(),0);
                for( size_t k = 0; k < vi.size(); k++ )
                    svi[k] = vi[sigma[k]];
                size_t sli = smi.li(svi);
                if( verbose >= 3 ) {
                    cout << "    " << li << ": ";
                    copy( vi.begin(), vi.end(), ostream_iterator<size_t>(cout," "));
                    cout << "-> ";
                    copy( svi.begin(), svi.end(), ostream_iterator<size_t>(cout," "));
                    cout << ": " << sli << endl;
                }
                factors.back()[sli] = val;
            }
        }

        if( verbose >= 3 ) {
            cout << "factors:" << endl;
            copy(factors.begin(), factors.end(), ostream_iterator<Factor>(cout,"\n"));
        }

        fg = FactorGraph(factors);
    } catch (char *e) {
        cout << e << endl;
    }

    return is;
}


long FactorGraph::ReadFromFile(const char *filename) {
    ifstream infile;
    infile.open (filename);
    if (infile.is_open()) {
        infile >> *this;
        infile.close();
        return 0;
    } else {
        cout << "ERROR OPENING FILE" << endl;
        return 1;
    }
}


long FactorGraph::WriteToFile(const char *filename) const {
    ofstream outfile;
    outfile.open (filename);
    if (outfile.is_open()) {
        try {
            outfile << *this;
        } catch (char *e) {
            cout << e << endl;
            return 1;
        }
        outfile.close();
        return 0;
    } else {
        cout << "ERROR OPENING FILE" << endl;
        return 1;
    }
}
*/


FactorGraph readVibStream (std::istream& is) {
    long verbose = 3;

    try {
        vector<Factor> factors;

        string line;
//        while( (is.peek()) == '#' )
//            getline(is,line);
        
        size_t nr_v;
        is >> nr_v;
        if( is.fail() )
            DAI_THROW(INVALID_FACTORGRAPH_FILE);
        if( verbose >= 2 )
            cout << "Reading " << nr_v << " variables..." << endl;
        vector<size_t> vardims;
        for( size_t i = 0; i < nr_v; i++ ) {
            if( verbose >= 3 )
                cout << "Reading variable " << i << "..." << endl;
            size_t nr_vals;
            is >> nr_vals;
            if( is.fail() )
                DAI_THROW(INVALID_FACTORGRAPH_FILE);
            if( verbose >= 3 )
                cout << "...has " << nr_vals << " values." << endl;
            vardims.push_back( nr_vals );
        }

        size_t nr_f;
        is >> nr_f;
        if( is.fail() )
            DAI_THROW(INVALID_FACTORGRAPH_FILE);
        if( verbose >= 2 )
            cout << "Reading " << nr_f << " factors..." << endl;

        for( size_t I = 0; I < nr_f; I++ ) {
            if( verbose >= 3 )
                cout << "Reading factor " << I << "..." << endl;
            size_t nr_members;
            is >> nr_members;
            if( is.fail() )
                DAI_THROW(INVALID_FACTORGRAPH_FILE);
            if( verbose >= 3 )
                cout << "  nr_members: " << nr_members << endl;

            vector<long> labels;
            for( size_t mi = 0; mi < nr_members; mi++ ) {
                long mi_label;
                is >> mi_label;
                if( is.fail() )
                    DAI_THROW(INVALID_FACTORGRAPH_FILE);
                labels.push_back(mi_label);
            }

            // do magic permutation
            vector<long> newlabels;
            newlabels.push_back( labels[0] );
            for( size_t mi = 0; mi < nr_members-1; mi++ )
                newlabels.push_back( labels[nr_members - 1 - mi] );
            labels = newlabels;

            if( verbose >= 3 ) {
                cout << "  labels: ";
                copy (labels.begin(), labels.end(), ostream_iterator<int>(cout, " "));
                cout << endl;
            }

            // add the Factor
            VarSet I_vars;
            for( size_t mi = 0; mi < nr_members; mi++ )
                I_vars += Var(labels[mi], vardims[labels[mi]]);
            factors.push_back(Factor(I_vars,0.0));

            // calculate permutation sigma (internally, members are sorted)
            vector<size_t> sigma(nr_members,0);
            VarSet::iterator j = I_vars.begin();
            for( size_t mi = 0; mi < nr_members; mi++,j++ ) {
                long search_for = j->label();
                vector<long>::iterator j_loc = find(labels.begin(),labels.end(),search_for);
                sigma[mi] = j_loc - labels.begin();
            }
            if( verbose >= 3 ) {
                cout << "  sigma: ";
                copy( sigma.begin(), sigma.end(), ostream_iterator<int>(cout," "));
                cout << endl;
            }

            vector<size_t> dims;
            for( size_t mi = 0; mi < nr_members; mi++ )
                dims.push_back( vardims[labels[mi]] );

            // calculate multindices
            Permute permindex( dims, sigma );
            
            // read values
            for( size_t k = 0; k < I_vars.states(); k++ ) {
                double val;
                is >> val;
                factors.back()[permindex.convert_linear_index(k)] = val;
            }
            if( verbose >= 3 ) {
                cout << "Factor " << I << ":" << endl;
                cout << factors.back() << endl;
            }
        }

        return FactorGraph(factors);
    } catch (char *e) {
        cout << e << endl;
        return FactorGraph();
    }
}


int main( int argc, char *argv[] ) {
    if( argc != 3 ) {
        cout << "Usage: " << argv[0] << " <in.vib> <out.fg>" << endl << endl;
        cout << "Converts .vib file to .fg file" << endl;
        return 1;
    } else {
        ifstream infile;
        infile.open (argv[1]);

        if (infile.is_open()) {
            FactorGraph fg = readVibStream(infile);
            infile.close();
            fg.WriteToFile( argv[2] );
            return 0;
        } else {
            cout << "ERROR OPENING FILE" << endl;
            return 1;
        }
    }
}
